#include <ghttp.h>
#include <ghttp_constants.h>


#include "webupdate.h"
#include "properties.h"
#include "urlencoder.h"
#include "search.h"



/* returns NULL if the list cannot be retrieved */
gchar *retrieve_web_list()
{
	gchar					*newrc;
	ghttp_request			*request;
	ghttp_status			status;
	gint					err;
	//ghttp_current_status	current_status;
	
	/* Allocate a request */
	gchar *url = get_property ("rc_web_home");
	
	/* Allocate a request */
	request = ghttp_request_new();
	//printf ("set uri.\n");
	
	/* Set the URI, type, sync properties;
	   prepare the request and fire it off */
	err = ghttp_set_uri (request, url);
	if (err != -1)
	{
		err = ghttp_set_type (request, ghttp_type_get);
		if (err != -1)
		{
			err = ghttp_set_sync (request, ghttp_sync);
			if (err != -1)
			{
				err = ghttp_prepare (request);
				if (err != -1)
				{
					status = ghttp_process(request);
			//		while (status == ghttp_not_done)
			//		{
			//			current_status = ghttp_get_status(request);
			//			printf ("%d / %d\n", current_status.bytes_read,
			//				    current_status.bytes_total);
			//		}
				}
			}
		}
	}
	
	//current_status = ghttp_get_status(request);
	//printf ("%d total bytes.\n", current_status.bytes_read);
	
	if (err == -1)
	{
		printf ("web update error:\n%s\n", ghttp_get_error(request));
		return NULL;
	}

	newrc = ghttp_get_body(request);
	
	err = ghttp_close(request);
	if (err)
	{
		printf ("error closing request:\n%s", ghttp_get_error(request));
		return NULL;
	}
	
	ghttp_request_destroy(request);
	
	return newrc;
}


void strip_cr(gchar *txt) {
	gint len = strlen (txt);
	gint i;
	for (i=0; i<len; i++)
		if (txt[i] == '\r') txt[i] = '\n';
}



void install_updated_web_list()
{
	gchar *newrc;
	FILE *f;
	gint err;
	gint good = TRUE;
	
	//printf ("web update command received.\n");
	
	/* Obtain the online file. */
	newrc = retrieve_web_list();
	
	if (newrc == NULL)
	{
		printf ("Could not get web update, aborting operation.\n");
		return;
	}
	
	/* Convert lame wintel generated line separators to unix style, if any. */
	strip_cr (newrc);
	
	//printf ("new rc file:\n%s\n", newrc);
	//printf (".rc file obtained (and stripped). Saving to disk.\n");

	/* Carefully write the file to disk. */
	f = fopen (".netferretrc", "w");

	if (!f)
	{
		printf ("Error opening file \".netferretrc\"\nReverting to defaults.\n");
		good = FALSE;
	}
	
	if (good)
	{
		err = fputs (newrc, f);
		if (err == EOF)
		{
			printf ("EOF Error when writing file \".netferretrc\"\nReverting to defaults.\n");
			good = FALSE;
		}
		
		if (good)
		{
			err = fflush(f);
			if (err)
			{
				printf ("Error [%d] when flushing file \".netferretrc\"\nReverting to defaults.\n",
						 err);
				good = FALSE;
			}
			
			if (good)
			{
				err = fclose(f);
				if (err)
				{
					printf ("Error [%d] when closing file \".netferretrc\"\nReverting to defaults.\n",
							 err);
					good = FALSE;
				}
			}
		}
	}
	
	//printf ("Reinitializing environment\n");
	reinit_environment();
}

